'SpeedTouch Visual Basic Script
'Version:	0.5
'Created:	April 22, 2003
'Last Modified:	December 28, 2004
'Copyright:	2003 and 2004, Rene Dijkmans
'Redistribution and adaption of this script is permitted, as long as original source is named.
'Suitable for Windows XP or Windows 2000 in combination with a SpeedTouch 510(i) Modem and Serious Samurize.
'
'Description:	The script returns the amount of data uploaded, downloaded or total traffic during a given 
'		timespan, gathered from the HTML-status page of your SpeedTouch 510(i) Modem. Though the script
'		was written for the 510(i), the script works for most - if not all - SpeedTouch Modems having a 
'		web-interface which includes a statuspage ("/status.htm" or "/cgi/status/no_wizard").
'
'Usage:		From within Serious Samurize, choose the script and one of its functions. In order to use the 
'		script, enter CalWeek, RunWeek, CalMonth, RunMonth, CalYear or RunYear as the "timespan" 
'		parameter and enter kB, MB, GB, TB, PB or EB (*grin*) as the "unit" parameter.
'
'Note:		As parameters are used, you'll need at least Samurize v0.85 beta in order to run the script.
'		I suggest that you set the "Run every X min" to, lets say, 15 minutes. If the IP of your modem isn't
'		10.0.0.138, please change that value on line 50 of the script.
'
'ChangeLog:	version 0.50 - edited script to work with new firmware and removed uploadspeed and downloadspeed.
'		version 0.41 - created a workaround for the case that the modem is up, but the status.htm is not available
'		Version 0.40 - Some cosmetic reprogramming, fix for people who do not have 'ping' withing their 
'		               path scope, changed Speedtouch Pro in Speedtouch 510(i) and noted on which modems
'			       the script most likely will work.
'		Version 0.31 - Some bugfixing regarding resets of the modem
'		Version 0.30 - Lots of bugfixing and added functions UploadSpeed and DownloadSpeed
'		Version 0.25 - Adapted script so it doesn't write to file if the modem is not reachable
'		Version 0.22 - Major bugfix
'		Version 0.21 - Minor bugfix
'		Version 0.2  - Added variable unit and timespan
'		Version 0.1  - First working version, displayed figures in GB for the calender-month
'
'ICQ:		72828902
'MSN:		N0SPA|\/|rene@dijkmans.net




'-----------------------------------------------------------------------
' GENERAL INFORMATION FOR THE VBS TO RUN
'-----------------------------------------------------------------------
Dim objFileSystem, objOutputFile, Http, CurrOutputFile
Set MyShell = CreateObject("WScript.Shell")
Set objFileSystem = CreateObject("Scripting.FileSystemObject")

CurrOutputFile 	= "speedtouch.slf"

IP		= "10.0.0.138"
TVU		= 0
TVD		= 0


'-----------------------------------------------------------------------
'CALCULATE THE CURRDATE AND THE COMPDATE
'-----------------------------------------------------------------------
If DatePart("d",Date) < 10 Then CurrDay = 0 & DatePart("d",Date) Else CurrDay = DatePart("d",Date) End If
If DatePart("m",Date) < 10 Then CurrMonth = 0 & DatePart("m",Date) Else CurrMonth = DatePart("m",Date) End If
CurrYear = DatePart("yyyy",Date)
CurrDate = CurrYear & CurrMonth & CurrDay

Private Function CalculateCompDate(TimeSpan)
	If TimeSpan = "CalWeek" Then
		Distraction = 0
		Do until DayOfWeek = 1 'Sunday'
			Distraction = Distraction + 1
			DayOfWeek = Weekday(Date - Distraction, vbSunday)
		Loop
		RedefineDate = DateAdd("d",-Distraction,Date)	
	Elseif TimeSpan = "RunWeek" Then
		RedefineDate = DateAdd("d",-8,Date)
	Elseif TimeSpan = "CalMonth" Then
		RedefineDate = DateAdd("d",-CurrDay,Date)
	Elseif TimeSpan = "RunMonth" Then
		If DatePart("d",DateAdd("d",-28,Date)) = DatePart("d",Date) Then RedefineDate = DateAdd("d",-29,Date) End If
		If DatePart("d",DateAdd("d",-29,Date)) = DatePart("d",Date) Then RedefineDate = DateAdd("d",-30,Date) End If
		If DatePart("d",DateAdd("d",-30,Date)) = DatePart("d",Date) Then RedefineDate = DateAdd("d",-31,Date) End If
		If DatePart("d",DateAdd("d",-31,Date)) = DatePart("d",Date) Then RedefineDate = DateAdd("d",-32,Date) End If
	End If
	CompYear  = DatePart("yyyy",RedefineDate)
	If Timespan = "RunYear" Then
		CompYear = DatePart("yyyy",Date) - 1
		RedefineDate = DateAdd("d",-1,Date)
	Elseif TimeSpan = "CalYear" Then
		CompYear = DatePart("yyyy",Date) - 1
		CompMonth = "12"
		CompDay = "31"
	End If
	If DatePart("d",RedefineDate) < 10 Then CompDay = 0 & DatePart("d",RedefineDate) Else CompDay = DatePart("d",RedefineDate) End If
	If DatePart("m",RedefineDate) < 10 Then CompMonth = 0 & DatePart("m",RedefineDate) Else CompMonth = DatePart("m",RedefineDate) End If
	CalculateCompDate = CompYear & CompMonth & CompDay
End Function


'-----------------------------------------------------------------------
'CALCULATE THE FACTOR FOR DISPLAYING
'-----------------------------------------------------------------------
Private Function CalculateFactor(Unit)
	If Unit = "kB" Then
				CalculateFactor = 0
	Elseif Unit = "MB" Then CalculateFactor = 1
	Elseif Unit = "GB" Then CalculateFactor = 2
	Elseif Unit = "TB" Then CalculateFactor = 3
	Elseif Unit = "PB" Then CalculateFactor = 4
	Elseif Unit = "EB" Then CalculateFactor = 5 
	End If
End Function


'-----------------------------------------------------------------------
' FUNCTION TO GET CVU AND CVD FROM THE MODEMS STATUS PAGE
'-----------------------------------------------------------------------
Private Function GetFromStatus()
	'On Error Resume Next
	Set WMIServices = GetObject("winmgmts:\\.")
	For Each Object In WMIServices.InstancesOf("Win32_OperatingSystem")
   		SYS32Dir = Object.WindowsDirectory & "\SYSTEM32\"
	Next
	PingMachine = "%comspec% /c " & SYS32Dir & "ping.exe -n 1 -a " & IP & " >speedtouch.txt"
	Return = MyShell.Run(PingMachine,0,True) 
	Set File2Read=ObjFileSystem.OpenTextFile("speedtouch.txt")       
	ReadPing = File2Read.Readall
	If instr(ReadPing, "ytes=") > 0 Then
		Set Http = CreateObject("Microsoft.XMLhttp")
		'FOR NEW FIRMWARES
		Http.Open "GET","http://" & IP & "/cgi/status/no_wizard", False
		Http.Send
		If Instr(Http.ResponseText, " 404 ") = 0 And Not Http.ResponseText = "" Then
			HtmlResult	= Http.ResponseText
			HtmlCVUStart	= InStr(HtmlResult, "kBytes Tx/Rx") + Len("kBytes Tx/Rx")    
			HtmlCVUEnd	= InStr(HtmlCVUStart, HtmlResult, " / ")
			HtmlCVDStart	= HtmlCVUEnd + 2   
			HtmlCVDEnd	= InStr(HtmlCVDStart, HtmlResult, "</td>")
		End If
		'FOR OLD FIRMWARES
		Http.Open "GET","http://" & IP & "/status.htm", False
		Http.Send
		If Instr(Http.ResponseText, " 404 ") = 0 And Not Http.ResponseText = "" Then
			HtmlResult	= Http.ResponseText
			HtmlResult	= TempHtmlResult
			HtmlCVUStart	= InStr(HtmlResult, "Send (kByte)") + Len("Send (kByte)")    
			HtmlCVUEnd	= InStr(HtmlCVUStart, HtmlResult, "Read (kByte)")
			HtmlCVDStart	= InStr(HtmlResult, "Read (kByte)") + Len("Read (kByte)")    
			HtmlCVDEnd	= InStr(HtmlCVDStart, HtmlResult, "<!-- end data -->")
		End If
		GetCVU		= Mid(HtmlResult, HtmlCVUStart, HtmlCVUEnd - HtmlCVUStart)
		GetCVD		= Mid(HtmlResult, HtmlCVDStart, HtmlCVDEnd - HtmlCVDStart)
		pos_deb		= InStr(1, GetCVU, "<")
		Do Until pos_deb= 0
			pos_fin	= InStr(pos_deb, GetCVU, ">")
			part_d	= Mid(GetCVU, 1, pos_deb - 1)
			part_f	= Mid(GetCVU, pos_fin + 1, Len(GetCVU) - pos_fin)
			GetCVU	= part_d & part_f
			pos_deb	= InStr(1, GetCVU, "<")
		Loop
		pos_deb		= InStr(1, GetCVD, "<")
		Do Until pos_deb= 0
			pos_fin	= InStr(pos_deb, GetCVD, ">")
			part_d	= Mid(GetCVD, 1, pos_deb - 1)
			part_f	= Mid(GetCVD, pos_fin + 1, Len(GetCVD) - pos_fin)
			GetCVD	= part_d & part_f
			pos_deb	= InStr(1, GetCVD, "<")
		Loop	
		GetFromStatus 	= GetCVU + 0 & " || " & GetCVD + 0
	End if
	Set File2Read=ObjFileSystem.GetFile("speedtouch.txt")    
	File2Read.Delete
End Function


'-----------------------------------------------------------------------
' READ FIGURES FROM AND WRITE NEW FIGURES TO SPEEDTOUCH.SLF
'-----------------------------------------------------------------------
Private Function Calculation(CompDate)
	On Error Resume Next
	Ready 		= "no"
	FileDate	= "00000001"
	LastDate	= "00000000"
	FirstRead	= "true"
	CVUandCVD	= GetFromStatus
	WScript.Echo(CVUandCVD)
	CVU		= Mid(CVUandCVD, 1, Instr(CVUandCVD, " || ")) + 0
	CVD		= Mid(CVUandCVD, Instr(CVUandCVD, " || ") + 4, Len(CVUandCVD)) + 0
	TVU		= 0
	TVD		= 0
	Set LogFile 	= objFileSystem.OpenTextFile(CurrOutputFile)
	Do until Ready 		= "yes"
		ReadNow 	= LogFile.Readall
		ReadStart	= InStr(ReadNow, "Date:") + Len("Date:")
		ReadEnd 	= InStr(ReadStart, ReadNow, " Up:")
		FileDate 	= Mid(ReadNow, ReadStart, ReadEnd - Readstart)
		ReadStart 	= InStr(ReadNow, " Up:") + Len(" Up:")
		ReadEnd 	= InStr(ReadStart, ReadNow, " Down:")
		FileVU 		= Mid(ReadNow, ReadStart, ReadEnd - Readstart)
		ReadStart 	= InStr(ReadNow, " Down:") + Len(" Down:")   
		ReadEnd 	= InStr(ReadStart, ReadNow, " EOL")
		FileVD 		= Mid(ReadNow, ReadStart, ReadEnd - Readstart)
		ReadNow 	= Mid(Readnow, ReadStart)
		If (LastDate+0) = (FileDate+0) Then
			If Not CVD = "not reachable" Then
				If LastDate < CurrDate Then
					Set LogFile = objFileSystem.OpenTextFile(CurrOutputFile, 8, True)
					LogFile.WriteLine("Date:" & CurrDate & " Up:" & CVU & " Down:" & CVD & " EOL")
					LogFile.Close
				Elseif (CVD+0) > (LastVD+0) Then
					Set OldFile = objFileSystem.OpenTextFile(CurrOutputFile)
					NewFile = OldFile.Readall
					OldFile.Close
					OldString = CurrDate & " Up:" & LastVU & " Down:" & LastVD
					NewString = CurrDate & " Up:" & CVU & " Down:" & CVD
					NewFile   = Replace(NewFile, OldString, NewString)
					Set RewriteLogFile = objFileSystem.OpenTextFile(CurrOutputFile, 2)
					RewriteLogFile.Write(NewFile)
					RewriteLogFile.Close
				End If
			End If	
		Ready = "yes"
		Else
			If FirstRead = "true" Then
				LastVU = FileVU
				LastVD = FileVD
			End If
			If (FileDate+0) <= (CompDate+0) Then
				LastVU = FileVU
				LastVD = FileVD
			End If
			If (FileDate+0) > (CompDate+0) Then
				If (FileVD+0) < (LastVD+0) Then
					LastVU = 0
					LastVD = 0
				End If
				TVU    = TVU + (FileVU - LastVU)
				TVD    = TVD + (FileVD - LastVD)
				LastVU = FileVU
				LastVD = FileVD
			End If
			If FileDate = "00000001" And Not CVD = "not reachable" Then
				Set LogFile = objFileSystem.OpenTextFile(CurrOutputFile, 8, True)
				LogFile.WriteLine("Date:" & CurrDate-1 & " Up:" & CVU & " Down:" & CVD & " EOL")
				LogFile.Close
				Ready = "yes"
			End If
		End If
		LastDate  = FileDate
		FirstRead = "false"
	Loop
End Function


'-----------------------------------------------------------------------
' FUNCTIONS WHICH GET THE APPROPRIATE DATA
'-----------------------------------------------------------------------
Function Upload(TimeSpan, Unit)
	CompDate	= CalculateCompDate(TimeSpan)
	Factor 		= CalculateFactor(Unit)
	Calculation(CompDate)
	Upload 		= TVU / (1024 ^ Factor)
End Function


Function Download(TimeSpan, Unit)
	CompDate	= CalculateCompDate(TimeSpan)
	Factor 		= CalculateFactor(Unit)
	Calculation(CompDate)
	Download 	= TVD / (1024 ^ Factor)
End Function


Function TotalTraffic(TimeSpan, Unit)
	CompDate	= CalculateCompDate(TimeSpan)
	Factor 		= CalculateFactor(Unit)
	Calculation(CompDate)
	TotalTraffic	= (TVD + TVU) / (1024 ^ Factor)
End Function